#!/bin/bash

TEMPLATES="templates"
VER=84

usage() {
   echo "Usage: genrefwf -r R0 -p p0 -w sigma -t jtot -j j1 -m m1 -n n1 -J j2 -M m2 -N n2 -i inputfile"
   exit 1
}

while getopts "r:p:w:t:j:m:n:J:M:N:i:h" opt; do
   case $opt in
   h)  usage ;;
   r)  r0=$OPTARG ;;
   p)  p0=$OPTARG ;;
   w)  sigma=$OPTARG ;;
   t)  jtot=$OPTARG ;;
   j)  j1=$OPTARG ;;
   m)  m1=$OPTARG ;;
   n)  n1=$OPTARG ;;
   J)  j2=$OPTARG ;;
   M)  m2=$OPTARG ;;
   N)  n2=$OPTARG ;;
   i)  propinp="$OPTARG" ;;
   esac
done

test "$r0" || usage
test "$p0" || usage
test "$sigma" || usage
test "$jtot" || usage
test "$j1" || usage
test "$m1" || usage
test "$n1" || usage
test "$j2" || usage
test "$m2" || usage
test "$n2" || usage
test "$propinp" || usage

oper="oper_$j1+$j2"
if [ ! -d "$oper" ]; then
   mpp -i "$propinp" -u "$TEMPLATES/h4.pl" \
       r0=$r0 p0=$p0 sigma=$sigma op="$oper" jtot=$jtot j1=$j1 n1=$n1 j2=$j2 n2=$n2 \
       < "$TEMPLATES/genoper.in" >| genoper.inp
   mctdh$VER -mnd genoper
   rm -f genoper.inp
fi

name="inwf_$j1$m1$n1+$j2$m2$n2"
mpp -i "$propinp" -u "$TEMPLATES/h4.pl" \
    r0=$r0 p0=$p0 sigma=$sigma op="$oper" jtot=$jtot j1=$j1 n1=$n1 m1=$m1 j2=$j2 n2=$n2 m2=$m2 name="$name" \
    < "$TEMPLATES/geninwf.in" >| geninwf.inp
mctdh$VER -mnd geninwf
rm -f geninwf.inp

